
#ifndef H_IMGTRIG
 #define H_IMGTRIG

#ifdef __cplusplus
 extern "C" {
#endif

/* Given the vertices of a triangle (in any order), rasterize the triangle
 * into scanlines from top to bottom. "Draw" those scanlines by calling
 * "scanline(y,xleft,xright)" for each row "y" covered by the triangle.
 * If you're drawing the triangle, note that the scanline covers pixels
 * [xleft..xright] inclusive.
 *   The user can provide a callback function that draws the triangle to the
 * screen, or to a buffer in memory, or does something completely different.
 *   If scanline(y,xleft,xright) returns non-zero, then this function
 * returns without processing any more scanlines.
 */
void plot_triangle(int x1, int y1,
                   int x2, int y2,
                   int x3, int y3,
                   int (*scanline)(int,int,int));

#ifdef __cplusplus
 }
#endif

#endif /* H_IMGTRIG */
